/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"

#if !defined(macintosh)
extern	int	_filbuf		args( (FILE *) );
#endif



/*
 * Globals.
 */
HELP_DATA *		help_first;
HELP_DATA *		help_last;

SHOP_DATA *		shop_first;
SHOP_DATA *		shop_last;

CHAR_DATA *		char_free;
EXTRA_DESCR_DATA *	extra_descr_free;
NOTE_DATA *		note_free;
OBJ_DATA *		obj_free;
PC_DATA *		pcdata_free;
PREDELAY_DATA *		predelay_free;
ROOM_INDEX_DATA *	room_free;
EXIT_DATA *		exit_free;

char			bug_buf		[2*MAX_INPUT_LENGTH];
CHAR_DATA *		char_list;
CHAR_DATA *		saving_npc_list;
CHAR_DATA *		combat_list = NULL;
char *			help_greeting;
char			log_buf		[2*MAX_INPUT_LENGTH];
NOTE_DATA *		note_list;
OBJ_DATA *		object_list;
TIME_INFO_DATA		time_info;
WEATHER_DATA		weather_info;

struct damage_mess	*death_table[ATTACK_MAX];
struct damage_mess	*damage_table[ATTACK_MAX];

sh_int			wpr_club;
sh_int			wpr_club_heavy;
sh_int			wpr_dagger;
sh_int			wpr_flail;
sh_int			wpr_half_staff;
sh_int			wpr_hammer;
sh_int			wpr_knife;
sh_int			wpr_pole_arms;
sh_int			wpr_scimitar;
sh_int			wpr_spear_long;
sh_int			wpr_spear_short;
sh_int			wpr_staff;
sh_int			wpr_sword_bastard;
sh_int			wpr_sword_broad;
sh_int			wpr_sword_long;
sh_int			wpr_sword_short;
sh_int			wpr_sword_two_handed;

sh_int			wpr_blowgun;
sh_int			wpr_bow_cross;
sh_int			wpr_bow_cross_heavy;
sh_int			wpr_bow_long;
sh_int			wpr_bow_short;

sh_int			wpr_thrown_boomerang;
sh_int			wpr_thrown_dart;
sh_int			wpr_thrown_knife;
sh_int			wpr_thrown_spear;

sh_int			gsn_acid_breath;
sh_int			gsn_archery;
sh_int			gsn_armor;
sh_int			gsn_backstab;
sh_int			gsn_bash;
sh_int			gsn_bleeding;		/* stores damage message */
sh_int			gsn_bless;
sh_int			gsn_blindness;
sh_int			gsn_blud_proficiency;
sh_int			gsn_call_lightning;
sh_int			gsn_charm_person;
sh_int			gsn_climbing;
sh_int			gsn_control_weather;
sh_int			gsn_create_food;
sh_int			gsn_create_water;
sh_int			gsn_cure_blindness;
sh_int			gsn_cure_poison;
sh_int			gsn_curse;
sh_int			gsn_detect_evil;
sh_int			gsn_detect_invis;
sh_int			gsn_detect_magic;
sh_int			gsn_detect_poison;
sh_int			gsn_disarm;
sh_int			gsn_dispel_evil;
sh_int			gsn_dispel_magic;
sh_int			gsn_dodge;
sh_int			gsn_dual_wield;
sh_int			gsn_earthquake;
sh_int			gsn_enchant_weapon;
sh_int			gsn_enhanced_damage;
sh_int			gsn_falling;
sh_int			gsn_fire_breath;
sh_int			gsn_fireball;
sh_int			gsn_flash;
sh_int			gsn_fly;
sh_int			gsn_frost_breath;
sh_int			gsn_gas_breath;
sh_int			gsn_gate;
sh_int			gsn_harm;
sh_int			gsn_heal;
sh_int			gsn_hide;
sh_int			gsn_identify;
sh_int			gsn_infravision;
sh_int			gsn_invis;
sh_int			gsn_kick;
sh_int			gsn_lightning_bolt;
sh_int			gsn_lightning_breath;
sh_int			gsn_locate_object;
sh_int			gsn_martial_arts;
sh_int			gsn_noquit;
sh_int			gsn_pass_door;
sh_int			gsn_pebble;
sh_int			gsn_peek;
sh_int			gsn_pick_lock;
sh_int			gsn_pierce_proficiency;
sh_int			gsn_poison;
sh_int			gsn_protection_from_evil;
sh_int			gsn_read_magic;
sh_int			gsn_remove_curse;
sh_int			gsn_rescue;
sh_int			gsn_sanctuary;
sh_int			gsn_sense_life;
sh_int			gsn_slash_proficiency;
sh_int			gsn_sleep;
sh_int			gsn_sneak;
sh_int			gsn_steal;
sh_int			gsn_stone_skin;
sh_int			gsn_strength;
sh_int			gsn_summon;
sh_int			gsn_teleport;
sh_int			gsn_tracking;
sh_int			gsn_tumbling;
sh_int			gsn_use_magical_devices;
sh_int			gsn_vampiric_touch;
sh_int			gsn_ventriloquate;
sh_int			gsn_vitality;
sh_int			gsn_weaken;
sh_int			gsn_word_of_recall;



/*
 * Locals.
 */
MOB_INDEX_DATA *	mob_index_hash		[MAX_KEY_HASH];
OBJ_INDEX_DATA *	obj_index_hash		[MAX_KEY_HASH];
ROOM_INDEX_DATA *	room_index_hash		[MAX_KEY_HASH];
char *			string_hash		[MAX_KEY_HASH];

AREA_DATA *		area_first;
AREA_DATA *		area_last;

char *			string_space;
char *			top_string;
char			str_empty	[1];

int			top_affect;
int			top_area;
int			top_ed;
int			top_exit;
int			top_help;
int			top_mob_index;
int			top_obj_index;
int			top_reset;
int			top_room;
int			top_shop;



/*
 * Memory management.
 * Increase MAX_STRING if you have too.
 * Tune the others only if you understand what you're doing.
 */
#define			MAX_STRING	1048576
#define			MAX_PERM_BLOCK	131072
#define			MAX_MEM_LIST	11

void *			rgFreeList	[MAX_MEM_LIST];
const int		rgSizeList	[MAX_MEM_LIST]	=
{
    16, 32, 64, 128, 256, 1024, 2048, 4096, 8192, 16384, 32768-64
};

int			nAllocString;
int			sAllocString;
int			nAllocPerm;
int			sAllocPerm;



/*
 * Semi-locals.
 */
bool			fBootDb;
FILE *			fpArea;
char			strArea[MAX_INPUT_LENGTH];



/*
 * Local booting procedures.
 */
void	init_mm		args( ( void ) );

void	load_area	args( ( FILE *fp ) );
void	load_helps	args( ( FILE *fp ) );
void	load_mobiles	args( ( FILE *fp ) );
void	load_objects	args( ( FILE *fp ) );
void	load_resets	args( ( FILE *fp ) );
void	load_rooms	args( ( FILE *fp ) );
void	load_notes	args( ( void ) );
void	load_dam_msg	args( ( void ) );
void	load_weat_msg	args( ( void ) );
void	load_saved_rooms args( ( void ) );

void	fix_exits	args( ( void ) );

void	reset_area	args( ( AREA_DATA * pArea ) );



/*
 * Big mama top level function.
 */
void boot_db( void )
{
    /*
     * Init some data space stuff.
     */
    {
	if ( ( string_space = calloc( 1, MAX_STRING ) ) == NULL )
	{
	    bug( "Boot_db: can't alloc %d string space.", MAX_STRING );
	    exit( 1 );
	}
	top_string	= string_space;
	fBootDb		= TRUE;
    }

    /*
     * Init random number generator.
     */
    {
	init_mm( );
    }

    /*
     * Set time and weather.
     */
    {
	long lhour, lday, lmonth;

	lhour		= (current_time - 650336715)
			/ (PULSE_TICK / PULSE_PER_SECOND);
	time_info.hour	= lhour  % 24;
	lday		= lhour  / 24;
	time_info.day	= lday   % 35;
	lmonth		= lday   / 35;
	time_info.month	= lmonth % 17;
	time_info.year	= lmonth / 17;

	     if ( time_info.hour <  5 ) weather_info.sunlight = SUN_DARK;
	else if ( time_info.hour <  6 ) weather_info.sunlight = SUN_RISE;
	else if ( time_info.hour < 19 ) weather_info.sunlight = SUN_LIGHT;
	else if ( time_info.hour < 20 ) weather_info.sunlight = SUN_SET;
	else                            weather_info.sunlight = SUN_DARK;

	weather_info.change	= 0;
	weather_info.mmhg	= 960;
	if ( time_info.month >= 7 && time_info.month <=12 )
	    weather_info.mmhg += number_range( 1, 50 );
	else
	    weather_info.mmhg += number_range( 1, 80 );

	     if ( weather_info.mmhg <=  980 ) weather_info.sky = SKY_LIGHTNING;
	else if ( weather_info.mmhg <= 1000 ) weather_info.sky = SKY_RAINING;
	else if ( weather_info.mmhg <= 1020 ) weather_info.sky = SKY_CLOUDY;
	else                                  weather_info.sky = SKY_CLOUDLESS;

    }

    /*
     * Assign gsn's for skills which have them.
     */
    {
	int sn;

	for ( sn = 0; sn < MAX_SKILL; sn++ )
	{
	    if ( skill_table[sn].pgsn != NULL )
		*skill_table[sn].pgsn = sn;
	}

    }

    /*
     * Assign gn's for wear locations
     */
    {
	int n;
	extern struct wear_data const wear_info[];

	for ( n = 0; n < MAX_WEAR; n++ )
	{
	    if ( wear_info[n].pgn != NULL )
		*wear_info[n].pgn = n;
	}
    }

    /*
     * Assign wprs for profis.
     */
    {
	int sn;

	for ( sn = 0; sn < MAX_PROFI; sn++ )
	{
	    if ( profi_table[sn].pwpr != NULL )
		*profi_table[sn].pwpr = sn;
	}
    }

    /*
     * Load races.  Needed for areas.
     */
    load_races( );

    /*
     * Load names.
     */
    load_names( );

    /*
     * Read in all the area files.
     */
    {
	FILE *fpList;

	if ( ( fpList = fopen( AREA_LIST, "r" ) ) == NULL )
	{
	    perror( AREA_LIST );
	    exit( 1 );
	}

	for ( ; ; )
	{
	    strcpy( strArea, fread_word( fpList ) );
	    if ( strArea[0] == '$' )
		break;

	    if ( strArea[0] == '-' )
	    {
		fpArea = stdin;
	    }
	    else
	    {
		if ( ( fpArea = fopen( strArea, "r" ) ) == NULL )
		{
		    perror( strArea );
		    exit( 1 );
		}
	    }
/* debug line */
/*
	sprintf( buf, "[*****] FILE: %s", strArea );
	log_string( buf );
*/

	    for ( ; ; )
	    {
		char *word;

		if ( fread_letter( fpArea ) != '#' )
		{
		    bug( "Boot_db: # not found.", 0 );
		    exit( 1 );
		}

		word = fread_word( fpArea );

		     if ( word[0] == '$'               )                 break;
		else if ( !str_cmp( word, "AREA"     ) ) load_area    (fpArea);
		else if ( !str_cmp( word, "HELPS"    ) ) load_helps   (fpArea);
		else if ( !str_cmp( word, "MOBILES"  ) ) load_mobiles (fpArea);
		else if ( !str_cmp( word, "OBJECTS"  ) ) load_objects (fpArea);
		else if ( !str_cmp( word, "RESETS"   ) ) load_resets  (fpArea);
		else if ( !str_cmp( word, "ROOMS"    ) ) load_rooms   (fpArea);
		else
		{
		    bug( "Boot_db: bad section name.", 0 );
		    exit( 1 );
		}
	    }

	    if ( fpArea != stdin )
		fclose( fpArea );
	    fpArea = NULL;
	}
	fclose( fpList );
    }

    /*
     * Read external messages
     */
    load_dam_msg( );
/*
    load_weat_msg( );
*/

    /*
     *  Load saved contents to rooms that save.
     */
    load_saved_rooms( );

    /*
     * Fix up exits.
     * Declare db booting over.
     * Reset all areas once.
     * Load up the notes file.
     */
    {
	fix_exits( );
	fBootDb	= FALSE;
/*	load_equipment_totals( ); */
	area_update( );
	load_notes( );
    }

    return;
}



/*
 * Snarf an 'area' header line.
 */
void load_area( FILE *fp )
{
    AREA_DATA *pArea;

    pArea		= alloc_perm( sizeof(*pArea) );
    pArea->reset_first	= NULL;
    pArea->reset_last	= NULL;
    pArea->mob_first	= NULL;
    pArea->mob_last	= NULL;
    pArea->room_first	= NULL;
    pArea->room_last	= NULL;
    pArea->obj_first	= NULL;
    pArea->obj_last	= NULL;
    pArea->name		= fread_string( fp );
    pArea->filename	= fread_string( fp );
    pArea->builders	= fread_string( fp );
    pArea->vnum_start	= fread_number( fp );
    pArea->vnum_final	= fread_number( fp );
    pArea->reset_length	= fread_number( fp );
    pArea->area_bits	= fread_number( fp );
    pArea->age		= 15;
    pArea->nplayer	= 0;

    if ( area_first == NULL )
	area_first = pArea;
    if ( area_last  != NULL )
	area_last->next = pArea;
    area_last	= pArea;
    pArea->next	= NULL;

    top_area++;
    return;
}



/*
 * Snarf a help section.
 */
void load_helps( FILE *fp )
{
    HELP_DATA *pHelp;

    for ( ; ; )
    {
	pHelp		= alloc_perm( sizeof(*pHelp) );
	pHelp->level	= fread_number( fp );
	pHelp->keyword	= fread_string( fp );
	if ( pHelp->keyword[0] == '$' )
	    break;
	pHelp->text	= fread_string( fp );

	if ( !str_cmp( pHelp->keyword, "greeting" ) )
	    help_greeting = pHelp->text;

	if ( help_first == NULL )
	    help_first = pHelp;
	if ( help_last  != NULL )
	    help_last->next = pHelp;

	help_last	= pHelp;
	pHelp->next	= NULL;
	top_help++;
    }

    return;
}



/*
 * Snarf a mob section.
 */
void load_mobiles( FILE *fp )
{
    int ii;
    MOB_INDEX_DATA *pMobIndex;
    EQUIP_DATA *pEquip;

    if ( area_last == NULL )
    {
	bug( "Load_resets: no #AREA seen yet.", 0 );
	exit( 1 );
    }

    for ( ; ; )
    {
	sh_int vnum;
	char letter;
	int iHash;

	letter				= fread_letter( fp );
	if ( letter != '#' )
	{
	    bug( "Load_mobiles: # not found.", 0 );
	    exit( 1 );
	}

	vnum				= fread_number( fp );
	if ( vnum == 0 )
	    break;

	fBootDb = FALSE;
	if ( get_mob_index( vnum ) != NULL )
	{
	    bug( "Load_mobiles: vnum %d duplicated.", vnum );
	    exit( 1 );
	}
	fBootDb = TRUE;

	pMobIndex			= alloc_perm( sizeof(*pMobIndex) );
	pMobIndex->vnum			= vnum;
	pMobIndex->area			= area_last;
	pMobIndex->name			= fread_string( fp );
	pMobIndex->namelist		= fread_string( fp );
	pMobIndex->short_descr		= fread_string( fp );
	pMobIndex->long_descr		= fread_string( fp );
	pMobIndex->description		= fread_string( fp );

	pMobIndex->long_descr[0]	= UPPER(pMobIndex->long_descr[0]);
	pMobIndex->description[0]	= UPPER(pMobIndex->description[0]);

	pMobIndex->spec_fun_name	= fread_string( fp );
	pMobIndex->spec_fun	= spec_lookup	( pMobIndex->spec_fun_name );

	pMobIndex->act			= fread_number( fp ) | ACT_IS_NPC;
	pMobIndex->affected_by		= fread_number( fp );
	pMobIndex->pShop		= NULL;
	pMobIndex->alignment		= fread_number( fp );
	pMobIndex->aggression		= fread_number( fp );
	pMobIndex->speed		= fread_number( fp );
	pMobIndex->clan			= fread_number( fp );
	letter				= fread_letter( fp );
	pMobIndex->level		= fread_number( fp );

	pMobIndex->hitnodice		= fread_number( fp );
	/* 'd'		*/		  fread_letter( fp );
	pMobIndex->hitsizedice		= fread_number( fp );
	/* '+'		*/		  fread_letter( fp );
	pMobIndex->hitplus		= fread_number( fp );
	pMobIndex->damnodice		= fread_number( fp );	
	/* 'd'		*/		  fread_letter( fp );
	pMobIndex->damsizedice		= fread_number( fp );
	/* '+'		*/		  fread_letter( fp );
	pMobIndex->damplus		= fread_number( fp );
	pMobIndex->mob_str		= fread_number( fp );
	pMobIndex->mob_int		= fread_number( fp );
	pMobIndex->mob_dex		= fread_number( fp );
	pMobIndex->mob_tou		= fread_number( fp );
	pMobIndex->mob_offense		= fread_number( fp );
	pMobIndex->mob_defense		= fread_number( fp );
	pMobIndex->absorb[0]		= fread_number( fp );
	pMobIndex->absorb[1]		= fread_number( fp );
	pMobIndex->absorb[2]		= fread_number( fp );
	pMobIndex->absorb[3]		= fread_number( fp );
	/* position	*/		  fread_number( fp );
	pMobIndex->start_pos		= fread_number( fp );

	/*
	 * Back to meaningful values.
	 */
	pMobIndex->sex			= fread_number( fp );

	pMobIndex->race			= race_lookup( fread_string( fp ) );
	pMobIndex->class		= fread_number( fp );
	pMobIndex->equipped		= NULL;

	for ( ii = 0; ii < MAX_COIN; ii++ )
	    pMobIndex->coins[ii] = 0;

	if ( IS_SET( pMobIndex->act, ACT_SHOPKEEPER ) )
	{
	    SHOP_DATA *pshop;

	    pshop = new_shop( );

	    for ( ii = 0; ii < MAX_TRADE; ii++ )
		pshop->buy_type[ii] = fread_number( fp );
	    pshop->profit_buy = fread_number( fp );
	    pshop->profit_sell = fread_number( fp );
	    pshop->open_hour = fread_number( fp );
	    pshop->close_hour = fread_number( fp );
	    pshop->gain = fread_number( fp );

	    for ( ii = 0; ii < SHOP_MAX_MESSAGE; ii++ )
		pshop->shop_messages[ii] = fread_string( fp );

	    pMobIndex->pShop = pshop;
	}

	if ( letter != 'S' )
	{
	    bug( "Load_mobiles: vnum %d non-S.", vnum );
	    exit( 1 );
	}

	for ( ; ; )
	{
	    letter = fread_letter( fp );

	    if ( letter == 'C' )
	    {
		/* C is used to assign currency exchange rates to shopkeeps */
		int coin;
		coin = get_coin_index( fread_word( fp ) );
		if ( coin == -1 || coin >= MAX_COIN
		|| pMobIndex->pShop == NULL )
		{
		    fread_number( fp );
		    fread_number( fp );
		    continue;
		}
		pMobIndex->pShop->coinage_buy[coin] = fread_number( fp );
		pMobIndex->pShop->coinage_sell[coin] = fread_number( fp );
	    }
	    else if ( letter == 'E' )
	    {
		pEquip = alloc_perm( sizeof( *pEquip ) );
		pEquip->item = fread_number( fp );
		pEquip->location = wear_loc_lookup( fread_word( fp ) );
		pEquip->next = pMobIndex->equipped;
		pMobIndex->equipped = pEquip;
	    }
	    else if ( letter == 'G' )
	    {
		int coin;
		coin = get_coin_index( fread_word( fp ) );
		if ( coin == -1 )
		    fread_number( fp );
		else
		    pMobIndex->coins[coin] = fread_number( fp );
	    }
	    else if ( letter == 'K' )
	    {
		if ( pMobIndex->skin_objects[0] == 0 )
		    pMobIndex->skin_objects[0] = fread_number( fp );
		else if ( pMobIndex->skin_objects[1] == 0 )
		    pMobIndex->skin_objects[1] = fread_number( fp );
		else if ( pMobIndex->skin_objects[2] == 0 )
		    pMobIndex->skin_objects[2] = fread_number( fp );
		else
		    pMobIndex->skin_objects[3] = fread_number( fp );
	    }
	    else if ( letter == 'S' )
	    {
		int sn;

		sn = skill_lookup( fread_word( fp ) );

		if ( sn == -1 )
		{
		    fread_number( fp );
		    fread_number( fp );
		}
		else
		{
		    pMobIndex->learned[sn] = fread_number( fp );
		    pMobIndex->power_level[sn] = fread_number( fp );
		}
	    }
	    else
	    {
		ungetc( letter, fp );
		break;
	    }
	}

	iHash			= vnum % MAX_KEY_HASH;
	pMobIndex->next		= mob_index_hash[iHash];
	mob_index_hash[iHash]	= pMobIndex;
	top_mob_index++;
	pMobIndex->zone_next = NULL;
	if (area_last->mob_first == NULL)
	{
	    area_last->mob_first = pMobIndex;
	    area_last->mob_last = pMobIndex;
	}
	else
	{
	    area_last->mob_last->zone_next = pMobIndex;
	    area_last->mob_last = pMobIndex;
	}
    }

    return;
}



/*
 * Snarf an obj section.
 */
void load_objects( FILE *fp )
{
    OBJ_INDEX_DATA *pObjIndex;

    if ( area_last == NULL )
    {
	bug( "Load_resets: no #AREA seen yet.", 0 );
	exit( 1 );
    }


    for ( ; ; )
    {
	int vnum;
	char letter;
	int iHash;

	letter				= fread_letter( fp );
	if ( letter != '#' )
	{
	    bug( "Load_objects: # not found.", 0 );
	    exit( 1 );
	}

	vnum				= fread_number( fp );
	if ( vnum == 0 )
	    break;

	fBootDb = FALSE;
	if ( get_obj_index( vnum ) != NULL )
	{
	    bug( "Load_objects: vnum %d duplicated.", vnum );
	    exit( 1 );
	}
	fBootDb = TRUE;

	pObjIndex			= alloc_perm( sizeof(*pObjIndex) );
	pObjIndex->vnum			= vnum;
	pObjIndex->area			= area_last;
	pObjIndex->name			= fread_string( fp );
	pObjIndex->short_descr		= fread_string( fp );
	pObjIndex->look_descr		= fread_string( fp );
	pObjIndex->description		= fread_string( fp );
	pObjIndex->spec_fun_name	= fread_string( fp );
	pObjIndex->spec_fun	= obj_fun_lookup ( pObjIndex->spec_fun_name );

	pObjIndex->material		= material_lookup( fread_word( fp ) );

	pObjIndex->short_descr[0]	= LOWER(pObjIndex->short_descr[0]);
	pObjIndex->look_descr[0]	= UPPER(pObjIndex->look_descr[0]);

	pObjIndex->item_type		= fread_number( fp );
	pObjIndex->extra_flags		= fread_number( fp );
	pObjIndex->wear_flags		= fread_number( fp );
	pObjIndex->color		= fread_number( fp );
	pObjIndex->value[0]		= fread_number( fp );
	pObjIndex->value[1]		= fread_number( fp );
	pObjIndex->value[2]		= fread_number( fp );
	pObjIndex->value[3]		= fread_number( fp );
	pObjIndex->weight		= fread_number( fp );
	pObjIndex->capacity		= fread_number( fp );
	pObjIndex->size			= fread_number( fp );
	pObjIndex->cost			= fread_number( fp );
	pObjIndex->load_chance		= fread_number( fp );
	pObjIndex->dam[0]		= fread_number( fp );
	pObjIndex->dam[1]		= fread_number( fp );
	pObjIndex->toughness		= fread_number( fp );
	pObjIndex->attack_type		= fread_number( fp );

	pObjIndex->limit	= -1;
	if ( pObjIndex->item_type == ITEM_KEY )
	    pObjIndex->limit = 1;

	for ( ; ; )
	{
	    char letter;

	    letter = fread_letter( fp );

	    if ( letter == 'A' )
	    {
		AFFECT_DATA *paf;

		paf			= alloc_perm( sizeof(*paf) );
		paf->type		= -1;
		paf->duration		= -1;
		paf->location		= fread_number( fp );
		paf->modifier		= fread_number( fp );
		paf->bitvector		= 0;
		paf->next		= pObjIndex->affected;
		pObjIndex->affected	= paf;
		top_affect++;
	    }

	    else if ( letter == 'E' )
	    {
		EXTRA_DESCR_DATA *ed;

		ed			= alloc_perm( sizeof(*ed) );
		ed->keyword		= fread_string( fp );
		ed->description		= fread_string( fp );
		ed->next		= pObjIndex->extra_descr;
		pObjIndex->extra_descr	= ed;
		top_ed++;
	    }

	    else if ( letter == 'L' )
	    {
		pObjIndex->limit = fread_number( fp );
	    }

	    else
	    {
		ungetc( letter, fp );
		break;
	    }
	}

	/*
	 * Translate spell "slot numbers" to internal "skill numbers."
	 */
	switch ( pObjIndex->item_type )
	{
	case ITEM_PILL:
	case ITEM_POTION:
	case ITEM_SCROLL:
	    pObjIndex->value[1] = slot_lookup( pObjIndex->value[1] );
	    pObjIndex->value[2] = slot_lookup( pObjIndex->value[2] );
	    pObjIndex->value[3] = slot_lookup( pObjIndex->value[3] );
	    break;

	case ITEM_STAFF:
	case ITEM_WAND:
	    pObjIndex->value[3] = slot_lookup( pObjIndex->value[3] );
	    break;
	}

	iHash			= vnum % MAX_KEY_HASH;
	pObjIndex->next		= obj_index_hash[iHash];
	obj_index_hash[iHash]	= pObjIndex;
	top_obj_index++;
	pObjIndex->zone_next = NULL;
	if (area_last->obj_first == NULL)
	{
	    area_last->obj_first = pObjIndex;
	    area_last->obj_last = pObjIndex;
	}
	else
	{
	    area_last->obj_last->zone_next = pObjIndex;
	    area_last->obj_last = pObjIndex;
	}
    }

    return;
}



/*
 * Snarf a reset section.
 */
void load_resets( FILE *fp )
{
    bool fValid;
    RESET_DATA *pReset;
    char buf[MAX_STRING_LENGTH];

    if ( area_last == NULL )
    {
	bug( "Load_resets: no #AREA seen yet.", 0 );
	exit( 1 );
    }

    for ( ; ; )
    {
	ROOM_INDEX_DATA *pRoomIndex;
	EXIT_DATA *pexit;
	char letter;

	fValid = TRUE;

	if ( ( letter = fread_letter( fp ) ) == 'S' )
	    break;

	if ( letter == '*' )
	{
	    fread_to_eol( fp );
	    continue;
	}

	pReset		= alloc_perm( sizeof(*pReset) );
	pReset->command	= letter;
	/* if_flag */	  fread_number( fp );
	pReset->arg1	= fread_number( fp );
	pReset->arg2	= fread_number( fp );
	if ( letter == 'G'
	|| letter == 'I'
	|| letter == 'R' )
	{
	}
	else if ( letter == 'E' )
	{
	    pReset->arg3	= wear_loc_lookup( fread_word( fp ) );
	}
	else
	    pReset->arg3	= fread_number( fp );

	fread_to_eol( fp );

	/*
	 * Validate parameters.
	 * We're calling the index functions for the side effect.
	 */
/* this is retarded.  it should check once, after the entire database
   has been read. */
#ifdef 0
	switch ( letter )
	{
	default:
	    sprintf( buf, "Load_resets: bad command '%c'.", letter );
	    log_string( buf );
/*
	    exit( 1 );
*/
	    fValid = FALSE;
	    break;

	case 'M':
	    if ( get_mob_index  ( pReset->arg1 ) == NULL )
		fValid = FALSE;
	    if ( get_room_index ( pReset->arg3 ) == NULL )
		fValid = FALSE;
	    break;

	case 'O':
	    if ( get_obj_index  ( pReset->arg1 ) == NULL )
		fValid = FALSE;
	    if ( get_room_index ( pReset->arg3 ) == NULL )
		fValid = FALSE;
	    break;

	case 'P':
	    if ( get_obj_index  ( pReset->arg1 ) == NULL )
		fValid = FALSE;
	    if ( get_obj_index  ( pReset->arg3 ) == NULL )
		fValid = FALSE;
	    break;

	case 'G':
	case 'E':
	case 'I':
	    if ( get_obj_index  ( pReset->arg1 ) == NULL )
		fValid = FALSE;
	    break;

	case 'D':
	    if ( (pRoomIndex = get_room_index( pReset->arg1 )) == NULL )
	    {
		fValid = FALSE;
		break;
	    }

	    if ( pReset->arg2 < 0
	    ||   pReset->arg2 > 5
	    || ( pexit = pRoomIndex->exit[pReset->arg2] ) == NULL
	    || !IS_SET( pexit->exit_flags, EX_ISDOOR ) )
	    {
		sprintf( buf, "Load_resets: 'D': exit %d not door.", pReset->arg2 );
		log_string( buf );
		fValid = FALSE;
/*
		exit( 1 );
*/
	    }

	    if ( pReset->arg3 < 0 || pReset->arg3 > 2 )
	    {
		sprintf( buf, "Load_resets: 'D': bad 'locks': %d.", pReset->arg3 );
		log_string( buf );
		fValid = FALSE;
/*
		exit( 1 );
*/
	    }

	    break;

	case 'R':
	    if ( (pRoomIndex = get_room_index( pReset->arg1 )) == NULL)
	    {
		fValid = FALSE;
		break;
	    }

	    if ( pReset->arg2 < 0 || pReset->arg2 > 6 )
	    {
		sprintf( buf, "Load_resets: 'R': bad exit %d.", pReset->arg2 );
		log_string( buf );
		fValid = FALSE;
/*
		exit( 1 );
*/
	    }

	    break;
	}
#endif
	if ( fValid == FALSE )
	    continue;

	if ( area_last->reset_first == NULL )
	    area_last->reset_first	= pReset;
	if ( area_last->reset_last  != NULL )
	    area_last->reset_last->next	= pReset;
	    
	area_last->reset_last	= pReset;
	pReset->next		= NULL;
	top_reset++;
    }

    return;
}



/*
 * Snarf a room section.
 */
void load_rooms( FILE *fp )
{
    ROOM_INDEX_DATA *pRoomIndex;

    if ( area_last == NULL )
    {
	bug( "Load_resets: no #AREA seen yet.", 0 );
	exit( 1 );
    }

    for ( ; ; )
    {
	int vnum;
	char letter;
	int door;
	int iHash;

	letter				= fread_letter( fp );
	if ( letter != '#' )
	{
	    bug( "Load_rooms: # not found.", 0 );
	    exit( 1 );
	}

	vnum				= fread_number( fp );
	if ( vnum == 0 )
	    break;

	fBootDb = FALSE;
	if ( get_room_index( vnum ) != NULL )
	{
	    bug( "Load_rooms: vnum %d duplicated.", vnum );
	    exit( 1 );
	}
	fBootDb = TRUE;

	pRoomIndex			= alloc_perm( sizeof(*pRoomIndex) );
	pRoomIndex->people		= NULL;
	pRoomIndex->contents		= NULL;
	pRoomIndex->extra_descr		= NULL;
	pRoomIndex->area		= area_last;
	pRoomIndex->vnum		= vnum;
	pRoomIndex->name		= fread_string( fp );
	pRoomIndex->description		= fread_string( fp );
	pRoomIndex->spec_fun_name	= fread_string( fp );
	pRoomIndex->spec_fun = room_fun_lookup( pRoomIndex->spec_fun_name );
/*
	    if ( pRoomIndex->spec_fun == 0 )
	    {
		bug( "Load_specials: 'R': vnum %d.", pRoomIndex->vnum );
		exit( 1 );
	    }
*/
	pRoomIndex->sector_type	= sector_type_lookup( fread_word( fp ) );

	pRoomIndex->room_flags		= fread_number( fp );
	pRoomIndex->move_cost		= fread_number( fp );
	pRoomIndex->move_delay		= fread_number( fp );
	pRoomIndex->light		= fread_number( fp );
	pRoomIndex->size		= fread_number( fp );
	pRoomIndex->light_filter	= fread_number( fp );
	for ( door = 0; door <= 5; door++ )
	    pRoomIndex->exit[door] = NULL;

	for ( ; ; )
	{
	    letter = fread_letter( fp );

	    if ( letter == 'S' )
		break;

	    if ( letter == 'D' )
	    {
		EXIT_DATA *pexit;

		door = fread_number( fp );
		if ( door < 0 || door > 5 )
		{
		    bug( "Fread_rooms: vnum %d has bad door number.", vnum );
		    exit( 1 );
		}

		pexit			= alloc_perm( sizeof(*pexit) );
		pexit->description	= fread_string( fp );
		pexit->keyword		= fread_string( fp );
		pexit->exit_flags	= fread_number( fp );
		pexit->key		= fread_number( fp );
		pexit->vnum		= fread_number( fp );
		pexit->difficulty	= fread_number( fp );

		pRoomIndex->exit[door]	= pexit;
		top_exit++;
	    }
	    else if ( letter == 'E' )
	    {
		EXTRA_DESCR_DATA *ed;

		ed			= alloc_perm( sizeof(*ed) );
		ed->keyword		= fread_string( fp );
		ed->description		= fread_string( fp );
		ed->next		= pRoomIndex->extra_descr;
		pRoomIndex->extra_descr	= ed;
		top_ed++;
	    }
	    else
	    {
		bug( "Load_rooms: vnum %d has flag not 'DES'.", vnum );
		exit( 1 );
	    }
	}

	iHash			= vnum % MAX_KEY_HASH;
	pRoomIndex->next	= room_index_hash[iHash];
	room_index_hash[iHash]	= pRoomIndex;
	top_room++;
	pRoomIndex->zone_next = NULL;
	if (area_last->room_first == NULL)
	{
	    area_last->room_first = pRoomIndex;
	    area_last->room_last = pRoomIndex;
	}
	else
	{
	    area_last->room_last->zone_next = pRoomIndex;
	    area_last->room_last = pRoomIndex;
	}
    }

    return;
}




/*
 * Snarf notes file.
 */
void load_notes( void )
{
    FILE *fp;
    NOTE_DATA *pnotelast;

    if ( ( fp = fopen( NOTE_FILE, "r" ) ) == NULL )
	return;

    pnotelast = NULL;
    for ( ; ; )
    {
	NOTE_DATA *pnote;
	char letter;

	do
	{
	    letter = getc( fp );
	    if ( feof(fp) )
	    {
		fclose( fp );
		return;
	    }
	}
	while ( isspace(letter) );
	ungetc( letter, fp );

	pnote		= alloc_perm( sizeof(*pnote) );

	if ( str_cmp( fread_word( fp ), "sender" ) )
	    break;
	pnote->sender	= fread_string( fp );

	if ( str_cmp( fread_word( fp ), "date" ) )
	    break;
	pnote->date	= fread_string( fp );

	if ( str_cmp( fread_word( fp ), "to" ) )
	    break;
	pnote->to_list	= fread_string( fp );

	if ( str_cmp( fread_word( fp ), "subject" ) )
	    break;
	pnote->subject	= fread_string( fp );

	if ( str_cmp( fread_word( fp ), "text" ) )
	    break;
	pnote->text	= fread_string( fp );

	if ( note_list == NULL )
	    note_list		= pnote;
	else
	    pnotelast->next	= pnote;

	pnotelast	= pnote;
    }

    strcpy( strArea, NOTE_FILE );
    fpArea = fp;
    bug( "Load_notes: bad key word.", 0 );
    exit( 1 );
    return;
}


/*
 * Read all damage messages from file into array.
 * Allows different numbers of messages for each attack type
 */
void load_dam_msg( void )
{
    FILE *fp;
    char c = ' ', clast = 'a', letter;
    char buf[MAX_STRING_LENGTH];
    struct damage_mess *pMess;
    int value, valuelast = 0;

    /*
     * Init all pointers.
     */
    for ( value = 0; value < ATTACK_MAX; value++ )
    {
	death_table[value] = NULL;
	damage_table[value] = NULL;
    }

    value = -1;

    fclose( fpReserve );
    if ( ( fp = fopen( "damage.msg", "r" ) ) == NULL )
    {
	log_string( "**  Damage message file missing!  **" );
	exit( 1 );
    }

    letter = '\0';

    for ( ; ; )
    {
	clast = c;
	c = fread_letter( fp );

	if ( c == '*' ) 
	{
	    fread_to_eol( fp );
	    continue;
	}

	if ( c == '#' )
	{
	    valuelast = value;
	    value = fread_number( fp );

	    if ( value < 0 )
	    {
		fclose ( fp );
		fpReserve = fopen( NULL_FILE, "r" );
		break;
	    }

	    if ( value > ATTACK_MAX )
	    {
		sprintf( buf, "load_dam_msg: Bad damage type: %d", value );
		log_string( buf );
		exit( 1 );
	    }

	    fread_to_eol( fp );
	    continue;
	}

	if ( c == 'D' || c == 'N' )
	{
	    if ( value < 0 || value > ATTACK_MAX )
	    {
		log_string( "load_dam_msg: No attack type before messages" );
		exit( 1 );
	    }

	    pMess = alloc_perm( sizeof( *pMess ) );

	    pMess->min_damage = fread_number( fp );
	    pMess->message_char = fread_string( fp );
	    pMess->message_room = fread_string( fp );
	    pMess->message_victim = fread_string( fp );

	    if ( c == 'D' )
	    {
		pMess->next = death_table[value];
		death_table[value] = pMess;
	    }
	    else if ( c == 'N' )
	    {
		pMess->next = damage_table[value];
		damage_table[value] = pMess;
	    }

	    continue;
	}

	sprintf( buf, "load_dam_msg: c: %c, clast: %c, value: %d, valuelast: %d",
	    c, clast, value, valuelast );
	log_string( buf );

	log_string( "load_dam_msg: error in data file" );
	exit( 1 );
    }

    return;
}

/*
 * Go through all existing rooms, detecting rooms which potentially
 * could have a save file.  Load objects and mobiles for that room.
 */
void load_saved_rooms( )
{
    ROOM_INDEX_DATA *room;
    int i;
    extern void read_room( ROOM_INDEX_DATA *room );

    for ( i = 0; i < MAX_KEY_HASH; i++ )
    {
	for ( room = room_index_hash[i]; room != NULL; room = room->next )
	{
	    if ( IS_SET( room->room_flags, ROOM_SAVES_CONTENTS ) )
		read_room( room );
	}
    }

    return;
}



/*
 * Translate all room exits from virtual to real.
 * Has to be done after all rooms are read in.
 * Check for bad reverse exits.
 */
void fix_exits( void )
{
    ROOM_INDEX_DATA *pRoomIndex;
    EXIT_DATA *pexit;
    int iHash;
    int door;

    for ( iHash = 0; iHash < MAX_KEY_HASH; iHash++ )
    {
	for ( pRoomIndex  = room_index_hash[iHash];
	      pRoomIndex != NULL;
	      pRoomIndex  = pRoomIndex->next )
	{
	    bool fexit;

	    fexit = FALSE;
	    for ( door = 0; door <= 5; door++ )
	    {
		if ( ( pexit = pRoomIndex->exit[door] ) != NULL )
		{
		    fexit = TRUE;
		    if ( pexit->vnum <= 0 )
			pexit->to_room = NULL;
		    else
		    {
			pexit->to_room = get_room_index( pexit->vnum );
			if ( pexit == NULL )
			{
			    pexit->vnum = -1;
			    if ( pexit->description[0] == '\0'
			    && pexit->keyword[0] == '\0' )
			    {
				pRoomIndex->exit[door] = NULL;
				free( pexit );
			    }
			}
		    }
		}
	    }

	    if ( !fexit )
		SET_BIT( pRoomIndex->room_flags, ROOM_NO_MOB );
	}
    }

    return;
}



/*
 * Repopulate areas periodically.
 */
void area_update( void )
{
    AREA_DATA *pArea;

    for ( pArea = area_first; pArea != NULL; pArea = pArea->next )
    {
	pArea->age++;

	/*
	 * Check age and reset.
	 */
	if ( pArea->age >= pArea->reset_length && pArea->reset_length != 0 )
	{
	    reset_area( pArea );
	    pArea->age = number_range( 0, 3 );
	}
    }

    return;
}



/*
 * Reset one area.
 */
void reset_area( AREA_DATA *pArea )
{
    RESET_DATA *pReset;
    CHAR_DATA *mob;
    OBJ_DATA *obj_to;
    bool last;

    mob 	= NULL;
    obj_to	= NULL;
    last	= TRUE;
    for ( pReset = pArea->reset_first; pReset != NULL; pReset = pReset->next )
    {
	ROOM_INDEX_DATA *pRoomIndex;
	MOB_INDEX_DATA *pMobIndex;
	OBJ_INDEX_DATA *pObjIndex;
	OBJ_INDEX_DATA *pObjToIndex;
	EXIT_DATA *pexit;
	OBJ_DATA *obj;


	switch ( pReset->command )
	{
	default:
	    bug( "Reset_area: bad command %c.", pReset->command );
	    break;

	case 'M':
	    if ( pReset->target != NULL )
	    {
		last = FALSE;
		continue;
	    }

	    if ( ( pMobIndex = get_mob_index( pReset->arg1 ) ) == NULL )
	    {
		bug( "Reset_area: 'M': bad vnum %d.", pReset->arg1 );
		continue;
	    }

	    if ( ( pRoomIndex = get_room_index( pReset->arg3 ) ) == NULL )
	    {
		bug( "Reset_area: 'R': bad vnum %d.", pReset->arg3 );
		continue;
	    }

	    for ( mob = pRoomIndex->people; mob != NULL; mob = mob->next_in_room )
	    {
		if ( mob->pIndexData == NULL || mob->pIndexData != pMobIndex )
		    continue;

		if ( mob->pReset != NULL )
		    continue;

		mob->pReset = pReset;
		pReset->target = (void * ) mob;
		last = FALSE;
		break;
	    }

	    if ( mob != NULL )
		break;

	    mob = create_mobile( pMobIndex );

	    check_random_equip( mob );

	    char_to_room( mob, pRoomIndex, FALSE );

	    pReset->target = (void *) mob;
	    mob->pReset = pReset;
	    last  = TRUE;
	    break;

	case 'O':
	    if ( pReset->target != NULL )
	    {
		last = FALSE;
		obj_to = (OBJ_DATA *) pReset->target;
		continue;
	    }

	    if ( ( pObjIndex = get_obj_index( pReset->arg1 ) ) == NULL )
	    {
		bug( "Reset_area: 'O': bad vnum %d.", pReset->arg1 );
		continue;
	    }

	    if ( ( pRoomIndex = get_room_index( pReset->arg3 ) ) == NULL )
	    {
		bug( "Reset_area: 'O': bad room %d.", pReset->arg3 );
		continue;
	    }

	    for ( obj = pRoomIndex->contents; obj != NULL; obj = obj->next_content )
	    {
		if ( obj->pIndexData == NULL || obj->pIndexData != pObjIndex )
		    continue;

		if ( obj->pReset != NULL )
		    continue;

		obj->pReset = pReset;
		pReset->target = (void * ) obj;
		last = FALSE;
		obj_to = obj;
		break;
	    }

	    if ( obj != NULL )
		break;

	    if ( pObjIndex->number >= 0
	    && pObjIndex->number >= pObjIndex->limit
	    && pObjIndex->limit >= 0 )
	    {
		last = TRUE;
		if ( pObjIndex->capacity <= 0 )
		    last = FALSE;
		break;
	    }

	    if ( number_percent() > pObjIndex->load_chance )
	    {
		last = TRUE;
		if ( pObjIndex->capacity <= 0 )
		    last = FALSE;
		break;
	    }

	    obj       = create_object( pObjIndex );
	    obj_to_room( obj, pRoomIndex, FALSE );
	    pReset->target = (void *) obj;
	    obj->pReset = pReset;
	    last = TRUE;
	    obj_to = obj;
	    break;

	case 'P':
	    if ( pReset->target != NULL )
	    {
		last = FALSE;
		continue;
	    }

	    if ( ( pObjIndex = get_obj_index( pReset->arg1 ) ) == NULL )
	    {
		bug( "Reset_area: 'P': bad vnum %d.", pReset->arg1 );
		continue;
	    }

/*
	    if ( ( pObjToIndex = get_obj_index( pReset->arg3 ) ) == NULL )
	    {
		bug( "Reset_area: 'P': bad vnum %d.", pReset->arg3 );
		continue;
	    }

	    if ( ( obj_to = get_obj_type( pObjToIndex ) ) == NULL
	    ||   (obj_to->in_room == NULL && obj_to->carried_by == NULL )
	    ||   count_obj_list( pObjIndex, obj_to->contains ) > 0 )
	    {
		last = FALSE;
		break;
	    }
*/
	    if ( obj_to == NULL )
	    {
		last = FALSE;
		break;
	    }

	    for ( obj = obj_to->contains; obj != NULL; obj = obj->next_content )
	    {
		if ( obj->pIndexData == NULL || obj->pIndexData != pObjIndex )
		    continue;

		if ( obj->pReset != NULL )
		    continue;

		obj->pReset = pReset;
		pReset->target = (void * ) obj;
		last = FALSE;
		break;
	    }

	    if ( obj != NULL )
		break;

	    if ( pObjIndex->number >= 0
	    && pObjIndex->number >= pObjIndex->limit
	    && pObjIndex->limit >= 0 )
	    {
		last = TRUE;
		if ( pObjIndex->capacity <= 0 )
		    last = FALSE;
		break;
	    }

	    if ( number_percent() > pObjIndex->load_chance )
	    {
		last = TRUE;
		if ( pObjIndex->capacity <= 0 )
		    last = FALSE;
		break;
	    }
	    
	    obj = create_object( pObjIndex );
	    obj_to_obj( obj, obj_to );
	    pReset->target = (void *) obj;
	    obj->pReset = pReset;
	    last = TRUE;
	    break;

	case 'G':
	case 'E':
	case 'I':
	    if ( ( pObjIndex = get_obj_index( pReset->arg1 ) ) == NULL )
	    {
		bug( "Reset_area: 'E', 'G', or 'I': bad vnum %d.", pReset->arg1 );
		continue;
	    }

	    if ( !last )
		break;

	    if ( mob == NULL )
	    {
		bug( "Reset_area: 'E', 'G', or 'I': null mob for vnum %d.",
		    pReset->arg1 );
		last = FALSE;
		break;
	    }

	    if ( pObjIndex->number >= 0
	    && pObjIndex->number >= pObjIndex->limit
	    && pObjIndex->limit >= 0 )
	    {
		last = TRUE;
		if ( pObjIndex->capacity == 0 )
		    last = FALSE;
		break;
	    }

	    if ( number_percent() >  pObjIndex->load_chance )
	    {
		last = TRUE;
		if ( pObjIndex->capacity == 0 )
		    last = FALSE;
		break;
	    }

	    obj = create_object( pObjIndex );
	    obj_to_char( obj, mob );
	    if ( pReset->command == 'E' )
		equip_char( mob, obj, pReset->arg3 );
	    if ( pReset->command == 'I' )
		SET_BIT( obj->extra_flags, ITEM_INVENTORY );
	    last = TRUE;
	    break;

	case 'D':
	    if ( ( pRoomIndex = get_room_index( pReset->arg1 ) ) == NULL )
	    {
		bug( "Reset_area: 'D': bad vnum %d.", pReset->arg1 );
		continue;
	    }

	    if ( ( pexit = pRoomIndex->exit[pReset->arg2] ) == NULL )
		break;

	    switch ( pReset->arg3 )
	    {
	    case 0:
		REMOVE_BIT( pexit->exit_flags, EX_CLOSED );
		REMOVE_BIT( pexit->exit_flags, EX_LOCKED );
		break;

	    case 1:
		SET_BIT(    pexit->exit_flags, EX_CLOSED );
		REMOVE_BIT( pexit->exit_flags, EX_LOCKED );
		break;

	    case 2:
		SET_BIT(    pexit->exit_flags, EX_CLOSED );
		SET_BIT(    pexit->exit_flags, EX_LOCKED );
		break;
	    }

	    last = TRUE;
	    break;

	case 'R':
	    if ( ( pRoomIndex = get_room_index( pReset->arg1 ) ) == NULL )
	    {
		bug( "Reset_area: 'R': bad vnum %d.", pReset->arg1 );
		continue;
	    }

	    {
		int d0;
		int d1;

		for ( d0 = 0; d0 < pReset->arg2 - 1; d0++ )
		{
		    d1                   = number_range( d0, pReset->arg2-1 );
		    pexit                = pRoomIndex->exit[d0];
		    pRoomIndex->exit[d0] = pRoomIndex->exit[d1];
		    pRoomIndex->exit[d1] = pexit;
		}
	    }
	    break;
	}
    }

    return;
}



/*
 * Create an instance of a mobile.
 */
CHAR_DATA *create_mobile( MOB_INDEX_DATA *pMobIndex )
{
    CHAR_DATA *mob;
    int i;

    if ( pMobIndex == NULL )
    {
	bug( "Create_mobile: NULL pMobIndex.", 0 );
	exit( 1 );
    }

    if ( char_free == NULL )
    {
	mob		= alloc_perm( sizeof(*mob) );
    }
    else
    {
	mob		= char_free;
	char_free	= char_free->next;
    }

    clear_char( mob );
    mob->pIndexData	= pMobIndex;

    mob->name		= pMobIndex->name;
    mob->namelist	= pMobIndex->namelist;
    mob->short_descr	= pMobIndex->short_descr;
    mob->long_descr	= pMobIndex->long_descr;
    mob->description	= pMobIndex->description;
    mob->spec_fun_name	= pMobIndex->spec_fun_name;

    mob->spec_fun	= pMobIndex->spec_fun;
    mob->prompt		= NULL;

    mob->level		= pMobIndex->level;
    mob->act		= pMobIndex->act;
    mob->affected_by	= pMobIndex->affected_by;
    mob->alignment	= pMobIndex->alignment;
    mob->aggression	= pMobIndex->aggression;
    mob->speed		= pMobIndex->speed;
    mob->clan		= pMobIndex->clan;
    mob->sex		= pMobIndex->sex;
    mob->race		= pMobIndex->race;

    mob->max_hit	= dice( pMobIndex->hitnodice, pMobIndex->hitsizedice )
				+ pMobIndex->hitplus;
    mob->hit[HIT_LOC_BODY]		= mob->max_hit;

    mob->damnodice	= pMobIndex->damnodice;
    mob->damsizedice	= pMobIndex->damsizedice;
    mob->damplus	= pMobIndex->damplus;

    for ( i = 0; i < MAX_COIN; i++ )
    {
      if ( pMobIndex->coins[i] != 0 )
	gain_coin( mob, pMobIndex->coins[i], i, FALSE, NULL );
    }

    mob->perm_str	= pMobIndex->mob_str;
    mob->perm_int	= pMobIndex->mob_int;
    mob->perm_dex	= pMobIndex->mob_dex;
    mob->perm_tou	= pMobIndex->mob_tou;
    mob->perm_offense	= pMobIndex->mob_offense;
    mob->perm_defense	= pMobIndex->mob_defense;
    mob->absorb[0]	= pMobIndex->absorb[0];
    mob->absorb[1]	= pMobIndex->absorb[1];
    mob->absorb[2]	= pMobIndex->absorb[2];
    mob->absorb[3]	= pMobIndex->absorb[3];

    mob->height		= race_array[mob->race]->height_base
			+ dice( race_array[mob->race]->heightnodice,
				race_array[mob->race]->heightsizedice );

    mob->weight		= race_array[mob->race]->weight_base
			+ dice( race_array[mob->race]->weightnodice,
				race_array[mob->race]->weightsizedice );

    assign_name( mob );

    if ( pMobIndex->equipped != NULL )
    {
	OBJ_DATA *obj;
	EQUIP_DATA *pEquip;

	for ( pEquip = pMobIndex->equipped; pEquip != NULL; pEquip = pEquip->next )
	{
	    obj = create_object( get_obj_index( pEquip->item ) );

	    if ( obj == NULL )
		continue;

	    obj_to_char( obj, mob );

	    if ( pEquip->location != -1 )
	    {
		equip_char( mob, obj, pEquip->location );
	    }
	}
    }

    /*
     * Insert in list.
     */
    mob->next		= char_list;
    char_list		= mob;
    return mob;
}



/*
 * Create an instance of an object.
 */
OBJ_DATA *create_object( OBJ_INDEX_DATA *pObjIndex )
{
    static OBJ_DATA obj_zero;
    OBJ_DATA *obj;
    AFFECT_DATA *paf_to;
    AFFECT_DATA *paf_from;

    if ( pObjIndex == NULL )
    {
	bug( "Create_object: NULL pObjIndex.", 0 );
	exit( 1 );
    }

    if ( obj_free == NULL )
    {
	obj		= alloc_perm( sizeof(*obj) );
    }
    else
    {
	obj		= obj_free;
	obj_free	= obj_free->next;
    }

    *obj		= obj_zero;
    obj->pIndexData	= pObjIndex;
    obj->in_room	= NULL;
    obj->wear_loc	= gn_wear_none;

    obj->name		= pObjIndex->name;
    obj->short_descr	= pObjIndex->short_descr;
    obj->look_descr	= pObjIndex->look_descr;
    obj->description	= pObjIndex->description;
    obj->spec_fun_name	= pObjIndex->spec_fun_name;
    obj->spec_fun	= pObjIndex->spec_fun;
    obj->material	= pObjIndex->material;
    obj->item_type	= pObjIndex->item_type;
    obj->extra_flags	= pObjIndex->extra_flags;
    obj->wear_flags	= pObjIndex->wear_flags;
    obj->color		= pObjIndex->color;
    obj->value[0]	= pObjIndex->value[0];
    obj->value[1]	= pObjIndex->value[1];
    obj->value[2]	= pObjIndex->value[2];
    obj->value[3]	= pObjIndex->value[3];
    obj->weight		= pObjIndex->weight;
    obj->capacity	= pObjIndex->capacity;
    obj->size		= pObjIndex->size;
    obj->cost		= pObjIndex->cost;
    obj->dam[0]		= pObjIndex->dam[0];
    obj->dam[1]		= pObjIndex->dam[1];
    obj->toughness	= pObjIndex->toughness;
    obj->attack_type	= pObjIndex->attack_type;

    /*
     * Copy affects.
     */
    for (paf_from = pObjIndex->affected ; paf_from != NULL ; paf_from = paf_from->next )
    {
	if (affect_free == NULL)
	{
	    paf_to = alloc_perm(sizeof(*paf_to));
	}
	else
	{
	    paf_to = affect_free;
	    affect_free = affect_free->next;
	}

	paf_to->type		= paf_from->type;
	paf_to->duration	= paf_from->duration;
	paf_to->location	= paf_from->location;
	paf_to->modifier	= paf_from->modifier;
	paf_to->bitvector	= paf_from->bitvector;
	paf_to->next		= obj->affected;
	obj->affected	= paf_to;
    }

    /*
     * Mess with object properties.
     */
    switch ( obj->item_type )
    {
    default:
	bug( "Read_object: vnum %d bad type.", pObjIndex->vnum );
	break;

    case ITEM_LIGHT:
    case ITEM_TREASURE:
    case ITEM_FURNITURE:
    case ITEM_TRASH:
    case ITEM_CONTAINER:
    case ITEM_DRINK_CON:
    case ITEM_KEY:
    case ITEM_FOOD:
    case ITEM_BOAT:
    case ITEM_CORPSE:
    case ITEM_FOUNTAIN:
    case ITEM_WEAPON:
    case ITEM_ARMOR:
    case ITEM_MONEY:
    case ITEM_LOCKPICKS:
    case ITEM_BUILDING_OBJECT:
    case ITEM_BUILDING_WINDOW:
    case ITEM_WAGON_CONTROLS:
    case ITEM_RANGED_WEAPON:
    case ITEM_AMMUNITION:
	break;

    case ITEM_JEWELRY:
	rename_object_random( obj, TABLE_JEWELRY );
	break;

    case ITEM_SCROLL:
	rename_object_random( obj, TABLE_SCROLL );
	obj->value[0]	= number_fuzzy( obj->value[0] );
	break;

    case ITEM_WAND:
    case ITEM_STAFF:
	rename_object_random( obj, TABLE_STAFF );
	obj->value[0]	= number_fuzzy( obj->value[0] );
	obj->value[1]	= number_fuzzy( obj->value[1] );
	break;

    case ITEM_POTION:
    case ITEM_PILL:
	obj->value[0]	= number_fuzzy( number_fuzzy( obj->value[0] ) );
	break;
    }

    obj->next		= object_list;
    object_list		= obj;
    pObjIndex->number++;

    return obj;
}



/*
 * Clear a new character.
 */
void clear_char( CHAR_DATA *ch )
{
    static CHAR_DATA ch_zero;

    *ch				= ch_zero;
    ch->next_fighting		= NULL;
    ch->name			= &str_empty[0];
    ch->short_descr		= &str_empty[0];
    ch->long_descr		= &str_empty[0];
    ch->description		= &str_empty[0];
    ch->prompt			= NULL;
    ch->predelay_time		= 0;
    ch->predelay_info		= NULL;
    ch->position		= POS_STANDING;
    ch->hit[HIT_LOC_BODY]			= 20;
    ch->max_hit			= 20;
    ch->mana			= 100;
    ch->max_mana		= 100;
    ch->move			= 100;
    ch->max_move		= 100;
    ch->perm_str		= 40;
    ch->perm_int		= 40;
    ch->perm_dex		= 40;
    ch->perm_tou		= 40;
    ch->pReset			= NULL;
    ch->riding			= NULL;
    ch->switched_into		= NULL;
    return;
}



/*
 * Free a character.
 */
void free_char( CHAR_DATA *ch )
{
    OBJ_DATA *obj;
    OBJ_DATA *obj_next;
    AFFECT_DATA *paf;
    AFFECT_DATA *paf_next;

    for ( obj = ch->carrying; obj != NULL; obj = obj_next )
    {
	obj_next = obj->next_content;
	extract_obj( obj, FALSE );
    }

    for ( paf = ch->affected; paf != NULL; paf = paf_next )
    {
	paf_next = paf->next;
	affect_remove( ch, paf );
    }

    free_string( ch->name, MEM_MOB_NAME_FREE_CHAR );
    free_string( ch->namelist, MEM_MOB_NAMELIST_FREE_CHAR );
    free_string( ch->short_descr, MEM_MOB_SHORT_DESCR_FREE_CHAR );
    free_string( ch->long_descr, MEM_MOB_LONG_DESCR_FREE_CHAR );
    free_string( ch->description, MEM_MOB_DESCRIPTION_FREE_CHAR );
    free_string( ch->spec_fun_name, MEM_MOB_SPEC_FUN_NAME_FREE_CHAR );
    free_string( ch->prompt, MEM_GENERAL );

    free_predelay( ch->predelay_info );

    if ( ch->pcdata != NULL )
    {
	free_string( ch->pcdata->pwd, MEM_PCDATA );
	free_string( ch->pcdata->bamfin, MEM_PCDATA );
	free_string( ch->pcdata->bamfout, MEM_PCDATA );
	free_string( ch->pcdata->email_address, MEM_PCDATA );
	free_string( ch->pcdata->rejected, MEM_PCDATA );
	ch->pcdata->next = pcdata_free;
	pcdata_free      = ch->pcdata;
    }

    ch->next	     = char_free;
    char_free	     = ch;
    return;
}


void free_extra_descr( EXTRA_DESCR_DATA *ed )
{
    if ( ed == NULL )
	return;

    free_string( ed->keyword, MEM_DIRECTION_KEYWORD );
    free_string( ed->description, MEM_DIRECTION_DESCRIPTION );

    ed->next = extra_descr_free;
    extra_descr_free = ed;

    return;
}

EXTRA_DESCR_DATA *new_extra_descr( void )
{
    EXTRA_DESCR_DATA *ed;

    if ( extra_descr_free == NULL )
    {
	ed                  = alloc_perm( sizeof(*ed) );
    }
    else
    {
	ed                  = extra_descr_free;
	extra_descr_free    = extra_descr_free->next;
    }

    return ed;
}


void free_predelay( PREDELAY_DATA *p )
{
    if ( p == NULL )
	return;

    p->fnptr = (DO_FUN *) predelay_free;
    predelay_free = p;

    return;
}


PREDELAY_DATA *new_predelay( void )
{
    PREDELAY_DATA *p;

    if ( predelay_free == NULL )
    {
	p                  = alloc_perm( sizeof(*p) );
    }
    else
    {
	p                  = predelay_free;
	predelay_free      = (PREDELAY_DATA *) predelay_free->fnptr;
    }

    return p;
}


void free_shop( SHOP_DATA *pShop )
{
    int i;
    SHOP_DATA *p;
    extern char *shopkeeper_messages[SHOP_MAX_MESSAGE];

    for ( i = 0; i < SHOP_MAX_MESSAGE; i++ )
    {
      if ( pShop->shop_messages[i] != shopkeeper_messages[i] )
	free_string( pShop->shop_messages[i], MEM_MOB_SHOP_MESSAGE );
    }

    if ( pShop == shop_first )
    {
	shop_first = pShop->next;

	if ( pShop == shop_last )
	    shop_last = NULL;
    }
    else
    {
	for ( p = shop_first; p != NULL; p = p->next )
	    if ( p->next == pShop )
	    {
		p->next = pShop->next;
		if ( pShop == shop_last )
		    shop_last = p;
		break;
	    }
    }

    free_mem( pShop, sizeof( *pShop ) );

    return;
}


SHOP_DATA *new_shop( void )
{
    SHOP_DATA *pShop;
    int i;
    extern char *shopkeeper_messages[SHOP_MAX_MESSAGE];

    pShop = alloc_mem( sizeof(*pShop) );

    for ( i = 0; i < MAX_TRADE; i++ )
	pShop->buy_type[i] = 0;

    pShop->profit_buy = 80;
    pShop->profit_sell = 120;

    pShop->open_hour = 0;
    pShop->close_hour = 23;

    pShop->gain = 0;

    for ( i = 0; i < SHOP_MAX_MESSAGE; i++ )
	pShop->shop_messages[i] = shopkeeper_messages[i];

    for ( i = 0; i < MAX_COIN; i++ )
    {
	pShop->coinage_buy[i] = 100;
	pShop->coinage_sell[i] = 100;
    }

    if ( shop_first == NULL )
	shop_first = pShop;
    if ( shop_last  != NULL )
	shop_last->next = pShop;

    shop_last	= pShop;
    pShop->next	= NULL;
    top_shop++;

    return pShop;
}


/*
 * free_exit and new_exit use to_room as a temporary next pointer.
 */
void free_exit( EXIT_DATA *exit )
{
    if ( exit == NULL )
	return;

    free_string( exit->description, MEM_DIRECTION_DESCRIPTION );
    free_string( exit->keyword, MEM_DIRECTION_KEYWORD );

    exit->to_room = (ROOM_INDEX_DATA *) exit_free;
    exit_free = exit;

    return;
}

EXIT_DATA *new_exit( )
{
    EXIT_DATA *exit;

    if ( exit_free == NULL )
    {
	exit = alloc_perm( sizeof(*exit) );
    }
    else
    {
	exit = exit_free;
	exit_free = (EXIT_DATA *) exit->to_room;
    }

    return exit;
}

ROOM_INDEX_DATA *new_room( void )
{
    ROOM_INDEX_DATA *room;

    if ( room_free == NULL )
    {
	room = alloc_perm( sizeof(*room) );
    }
    else
    {
	room = room_free;
	room_free = room->next;
    }

    return room;
}


void free_room( ROOM_INDEX_DATA *room_from )
{
    ROOM_INDEX_DATA *room_to;
    ROOM_INDEX_DATA *pRoomIndex;
    ROOM_INDEX_DATA *pRoom_next;
    CHAR_DATA *vch;
    EXTRA_DESCR_DATA *ed;
    int door;
    int iHash;

    room_to = get_room_index( ROOM_VNUM_CHAT );

    if ( room_from == room_to )
    {
	bug("Attempted free of chat room.", 0 );
	return;
    }

    for ( door = 0; door <= 5; door++ )
    {
	if ( room_from->exit[door] != NULL
	&& room_from->exit[door]->to_room != NULL
	&& room_from->exit[door]->to_room->area == room_from->area )
	{
	    room_to = room_from->exit[door]->to_room;
	    break;
	}
    }

    while ( room_from->contents != NULL )
	extract_obj( room_from->contents, TRUE );

    for ( door = 0; door < 6; door++ )
	free_exit( room_from->exit[door] );

    while ( room_from->people != NULL )
    {
	if ( IS_NPC( room_from->people ) )
	{
	    extract_char( room_from->people, TRUE );
	}
	else
	{
	    char_from_room( (vch = room_from->people) );
	    char_to_room( vch, room_to, FALSE );
	    do_look( vch, "auto" );
	}
    }

    for ( iHash = 0; iHash < MAX_KEY_HASH; iHash++ )
    {
	if ( room_index_hash[iHash] == NULL )
	    continue;

	for ( pRoomIndex = room_index_hash[iHash]; pRoomIndex != NULL; pRoomIndex = pRoomIndex->next )
	{
	    for ( door = 0; door <= 5; door++ )
	    {
		if ( pRoomIndex->exit[door] != NULL )
		{
		    if ( pRoomIndex->exit[door]->to_room == room_from )
		    {
			pRoomIndex->exit[door]->to_room = NULL;
			pRoomIndex->exit[door]->vnum = 0;
			pRoomIndex->exit[door]->exit_flags = 0;
			pRoomIndex->exit[door]->key = 0;

			if ( pRoomIndex->exit[door]->description[0] == '\0'
			&& pRoomIndex->exit[door]->keyword[0] == '\0' )
			{
			    free_exit( pRoomIndex->exit[door] );
			    pRoomIndex->exit[door] = NULL;
			}
		    }
		}
	    }
	}
    }

    iHash = room_from->vnum % MAX_KEY_HASH;
    for ( pRoomIndex = room_index_hash[iHash]; pRoomIndex != NULL; pRoomIndex = pRoom_next )
    {
	pRoom_next = pRoomIndex->next;

	if ( pRoomIndex == room_from )
	{
	    room_index_hash[iHash] = pRoomIndex->next;
	    break;
	}

	if ( pRoomIndex->next == room_from )
	{
	    pRoomIndex->next = room_from->next;
	    break;
	}
    }

   if ( room_from->area->room_first == room_from )
   {
	room_from->area->room_first = room_from->zone_next;
	if ( room_from->zone_next == NULL )
	    room_from->area->room_last = NULL;
   }
   else
    for ( pRoomIndex = room_from->area->room_first; pRoomIndex != NULL; pRoomIndex = pRoom_next )
    {
	pRoom_next = pRoomIndex->zone_next;

	if ( pRoom_next == room_from )
	{
	    pRoomIndex->zone_next = pRoom_next->zone_next;
	    if ( room_from->zone_next == NULL )
		room_from->area->room_last = pRoomIndex;
	    break;
	}
    }

    free_string( room_from->name, MEM_ROOM_NAME );
    free_string( room_from->description, MEM_ROOM_DESCRIPTION );
    free_string( room_from->spec_fun_name, MEM_ROOM_SPECIAL_NAME );

    while ( room_from->extra_descr != NULL )
    {
	ed = room_from->extra_descr;

	room_from->extra_descr = ed->next;

	free_extra_descr( ed );
    }

    room_from->next = room_free;
    room_free = room_from;

    return;
}


/*
 * Get an extra description from a list.
 */
char *get_extra_descr( const char *name, EXTRA_DESCR_DATA *ed )
{
    for ( ; ed != NULL; ed = ed->next )
    {
	if ( is_name( name, ed->keyword ) )
	    return ed->description;
    }
    return NULL;
}



/*
 * Translates mob virtual number to its mob index struct.
 * Hash table lookup.
 */
MOB_INDEX_DATA *get_mob_index( int vnum )
{
    MOB_INDEX_DATA *pMobIndex;

    for ( pMobIndex  = mob_index_hash[vnum % MAX_KEY_HASH];
	  pMobIndex != NULL;
	  pMobIndex  = pMobIndex->next )
    {
	if ( pMobIndex->vnum == vnum )
	    return pMobIndex;
    }

    if ( fBootDb )
    {
	bug( "Get_mob_index: bad vnum %d.", vnum );
	exit( 1 );
    }

    return NULL;
}



/*
 * Translates mob virtual number to its obj index struct.
 * Hash table lookup.
 */
OBJ_INDEX_DATA *get_obj_index( int vnum )
{
    OBJ_INDEX_DATA *pObjIndex;

    for ( pObjIndex  = obj_index_hash[vnum % MAX_KEY_HASH];
	  pObjIndex != NULL;
	  pObjIndex  = pObjIndex->next )
    {
	if ( pObjIndex->vnum == vnum )
	    return pObjIndex;
    }

    if ( fBootDb )
    {
	bug( "Get_obj_index: bad vnum %d.", vnum );
	exit( 1 );
    }

    return NULL;
}



/*
 * Translates mob virtual number to its room index struct.
 * Hash table lookup.
 */
ROOM_INDEX_DATA *get_room_index( int vnum )
{
    ROOM_INDEX_DATA *pRoomIndex;
    char buf [MAX_STRING_LENGTH];

    for ( pRoomIndex  = room_index_hash[vnum % MAX_KEY_HASH];
	  pRoomIndex != NULL;
	  pRoomIndex  = pRoomIndex->next )
    {
	if ( pRoomIndex->vnum == vnum )
	    return pRoomIndex;
    }

    if ( fBootDb )
    {
	sprintf( buf, "Get_room_index: bad vnum %d.", vnum );
	log_string( buf );
/*
	exit( 1 );
*/
    }

    return NULL;
}



/*
 * Read a letter from a file.
 */
char fread_letter( FILE *fp )
{
    char c;

    do
    {
	c = getc( fp );
    }
    while ( isspace(c) );

    return c;
}



/*
 * Read a number from a file.
 */
int fread_number( FILE *fp )
{
    int number;
    bool sign;
    char c;

    do
    {
	c = getc( fp );
    }
    while ( isspace(c) );

    number = 0;

    sign   = FALSE;
    if ( c == '+' )
    {
	c = getc( fp );
    }
    else if ( c == '-' )
    {
	sign = TRUE;
	c = getc( fp );
    }

    if ( !isdigit(c) )
    {
	bug( "Fread_number: bad format.", 0 );
	exit( 1 );
    }

    while ( isdigit(c) )
    {
	number = number * 10 + c - '0';
	c      = getc( fp );
    }

    if ( sign )
	number = 0 - number;

    if ( c == '|' )
	number += fread_number( fp );
    else if ( c != ' ' )
	ungetc( c, fp );

    return number;
}


/*
 * Read and allocate space for a string from a file.
 * These strings are read-only and shared.
 * Strings are hashed:
 *   each string prepended with hash pointer to prev string,
 *   hash code is simply the string length.
 * This function takes 40% to 50% of boot-up time.
 */
char *fread_string( FILE *fp )
{
    return fread_string_full( fp, '~' );
}

/*
 * This allows strings terminated by newline and tilde only.
 */
char *fread_string_full( FILE *fp, char terminator )
{
    char *plast;
    char c;

    plast = top_string + sizeof(char *);
    if ( plast > &string_space[MAX_STRING - MAX_STRING_LENGTH] )
    {
	bug( "Fread_string: MAX_STRING %d exceeded.", MAX_STRING );
	exit( 1 );
    }

    /*
     * Skip blanks.
     * Read first char.
     */
    do
    {
	c = getc( fp );
    }
    while ( isspace(c) );

    if ( ( *plast++ = c ) == '~' )
	return &str_empty[0];

    for ( ;; )
    {
	/*
	 * Back off the char type lookup,
	 *   it was too dirty for portability.
	 *   -- Furey
	 */
	switch ( *plast = getc( fp ) )
	{
	default:
	    plast++;
	    break;

	case EOF:
	    bug( "Fread_string: EOF", 0 );
	    exit( 1 );
	    break;

	case '\\':
	    plast++;
	    *plast = getc( fp );
	    if ( *plast == '~' )
		plast[-1] = '~';
	    else
		plast++;
	    break;

	case '\r':
	    break;

	case '\n':
	    if ( terminator != '\n' )
	    {
		plast++;
		*plast++ = '\r';
		break;
	    }

	case '~':
	    plast++;
	    {
		union
		{
		    char *	pc;
		    char	rgc[sizeof(char *)];
		} u1;
		int ic;
		int iHash;
		char *pHash;
		char *pHashPrev;
		char *pString;

		plast[-1] = '\0';
		iHash     = UMIN( MAX_KEY_HASH - 1, plast - 1 - top_string );
		for ( pHash = string_hash[iHash]; pHash; pHash = pHashPrev )
		{
		    for ( ic = 0; ic < sizeof(char *); ic++ )
			u1.rgc[ic] = pHash[ic];
		    pHashPrev = u1.pc;
		    pHash    += sizeof(char *);

		    if ( top_string[sizeof(char *)] == pHash[0]
		    &&   !strcmp( top_string+sizeof(char *)+1, pHash+1 ) )
			return pHash;
		}

		if ( fBootDb )
		{
		    pString		= top_string;
		    top_string		= plast;
		    u1.pc		= string_hash[iHash];
		    for ( ic = 0; ic < sizeof(char *); ic++ )
			pString[ic] = u1.rgc[ic];
		    string_hash[iHash]	= pString;

		    nAllocString += 1;
		    sAllocString += top_string - pString;
		    return pString + sizeof(char *);
		}
		else
		{
		    return str_dup( top_string + sizeof(char *) );
		}
	    }
	}
    }
}



/*
 * Read to end of line (for comments).
 */
void fread_to_eol( FILE *fp )
{
    char c;

    do
    {
	c = getc( fp );
    }
    while ( c != '\n' && c != '\r' );

    do
    {
	c = getc( fp );
    }
    while ( c == '\n' || c == '\r' );

    ungetc( c, fp );
    return;
}



/*
 * Read one word (into static buffer).
 */
char *fread_word( FILE *fp )
{
    static char word[MAX_INPUT_LENGTH];
    char *pword;
    char cEnd;

    do
    {
	cEnd = getc( fp );
    }
    while ( isspace( cEnd ) );

    if ( cEnd == '\'' || cEnd == '"' )
    {
	pword   = word;
    }
    else
    {
	word[0] = cEnd;
	pword   = word+1;
	cEnd    = ' ';
    }

    for ( ; pword < word + MAX_INPUT_LENGTH; pword++ )
    {
	*pword = getc( fp );
	if ( cEnd == ' ' ? isspace(*pword) : *pword == cEnd )
	{
	    if ( cEnd == ' ' )
		ungetc( *pword, fp );
	    *pword = '\0';
	    return word;
	}
    }

    bug( "Fread_word: word too long.", 0 );
    bug( word, 0 );
    exit( 1 );
    return NULL;
}



/*
 * Allocate some ordinary memory,
 *   with the expectation of freeing it someday.
 */
void *alloc_mem( int sMem )
{
    void *pMem;
    int iList;

    for ( iList = 0; iList < MAX_MEM_LIST; iList++ )
    {
	if ( sMem <= rgSizeList[iList] )
	    break;
    }

    if ( iList == MAX_MEM_LIST )
    {
	bug( "Alloc_mem: size %d too large.", sMem );
	exit( 1 );
    }

    if ( rgFreeList[iList] == NULL )
    {
	pMem		  = alloc_perm( rgSizeList[iList] );
    }
    else
    {
	pMem              = rgFreeList[iList];
	rgFreeList[iList] = * ((void **) rgFreeList[iList]);
    }

    return pMem;
}



/*
 * Free some memory.
 * Recycle it back onto the free list for blocks of that size.
 */
void free_mem( void *pMem, int sMem )
{
    int iList;

    for ( iList = 0; iList < MAX_MEM_LIST; iList++ )
    {
	if ( sMem <= rgSizeList[iList] )
	    break;
    }

    if ( iList == MAX_MEM_LIST )
    {
	bug( "Free_mem: size %d too large.", sMem );
	exit( 1 );
    }

    * ((void **) pMem) = rgFreeList[iList];
    rgFreeList[iList]  = pMem;

    return;
}



/*
 * Allocate some permanent memory.
 * Permanent memory is never freed,
 *   pointers into it may be copied safely.
 */
void *alloc_perm( int sMem )
{
    static char *pMemPerm;
    static int iMemPerm;
    void *pMem;

    while ( sMem % sizeof(long) != 0 )
	sMem++;
    if ( sMem > MAX_PERM_BLOCK )
    {
	bug( "Alloc_perm: %d too large.", sMem );
	exit( 1 );
    }

    if ( pMemPerm == NULL || iMemPerm + sMem > MAX_PERM_BLOCK )
    {
	iMemPerm = 0;
	if ( ( pMemPerm = calloc( 1, MAX_PERM_BLOCK ) ) == NULL )
	{
	    perror( "Alloc_perm" );
	    exit( 1 );
	}
    }

    pMem        = pMemPerm + iMemPerm;
    iMemPerm   += sMem;
    nAllocPerm += 1;
    sAllocPerm += sMem;
    return pMem;
}



/*
 * Duplicate a string into dynamic memory.
 * Fread_strings are read-only and shared.
 */
char *str_dup( const char *str )
{
    char *str_new;

    if ( str[0] == '\0' )
	return &str_empty[0];

    if ( str >= string_space && str < top_string )
	return (char *) str;

    str_new = alloc_mem( strlen(str) + 1 );
    strcpy( str_new, str );
    return str_new;
}



/*
 * Free a string.
 * Null is legal here to simplify callers.
 * Read-only shared strings are not touched.
 */
void free_string( char *pstr, int mem_type )
{
    if ( pstr == NULL
    ||   pstr == &str_empty[0]
    || ( pstr >= string_space && pstr < top_string ) )
	return;


    if ( find_string_references( pstr, mem_type ) )
	return;

    free_mem( pstr, strlen(pstr) + 1 );
    return;
}


bool find_string_references( char *pstr, int mem_type )
{
    int iHash;
    int count = 0;
    int i;
    SHOP_DATA *p;
    MOB_INDEX_DATA *pMobIndex;
    CHAR_DATA *ch;
    OBJ_INDEX_DATA *pObjIndex;
    OBJ_DATA *obj;

    switch( mem_type )
    {
	case MEM_MOB_NAME_FREE_CHAR:
	    count++;
	case MEM_MOB_NAME:
	    for ( iHash = 0; iHash < MAX_KEY_HASH; iHash++ )
		for ( pMobIndex = mob_index_hash[iHash];
		pMobIndex != NULL; pMobIndex = pMobIndex->next )
		    if ( pMobIndex->name == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    for ( ch = char_list; ch != NULL; ch = ch->next )
		    if ( ch->name == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    break;

	case MEM_MOB_NAMELIST_FREE_CHAR:
	    count++;
	case MEM_MOB_NAMELIST:
	    for ( iHash = 0; iHash < MAX_KEY_HASH; iHash++ )
		for ( pMobIndex = mob_index_hash[iHash];
		pMobIndex != NULL; pMobIndex = pMobIndex->next )
		    if ( pMobIndex->namelist == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    for ( ch = char_list; ch != NULL; ch = ch->next )
		    if ( ch->namelist == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    break;

	case MEM_MOB_SHORT_DESCR_FREE_CHAR:
	    count++;
	case MEM_MOB_SHORT_DESCR:
	    for ( iHash = 0; iHash < MAX_KEY_HASH; iHash++ )
		for ( pMobIndex = mob_index_hash[iHash];
		pMobIndex != NULL; pMobIndex = pMobIndex->next )
		    if ( pMobIndex->short_descr == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    for ( ch = char_list; ch != NULL; ch = ch->next )
		    if ( ch->short_descr == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    break;

	case MEM_MOB_LONG_DESCR_FREE_CHAR:
	    count++;
	case MEM_MOB_LONG_DESCR:
	    for ( iHash = 0; iHash < MAX_KEY_HASH; iHash++ )
		for ( pMobIndex = mob_index_hash[iHash];
		pMobIndex != NULL; pMobIndex = pMobIndex->next )
		    if ( pMobIndex->long_descr == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    for ( ch = char_list; ch != NULL; ch = ch->next )
		    if ( ch->long_descr == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    break;

	case MEM_MOB_DESCRIPTION_FREE_CHAR:
	    count++;
	case MEM_MOB_DESCRIPTION:
	    for ( iHash = 0; iHash < MAX_KEY_HASH; iHash++ )
		for ( pMobIndex = mob_index_hash[iHash];
		pMobIndex != NULL; pMobIndex = pMobIndex->next )
		    if ( pMobIndex->description == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    for ( ch = char_list; ch != NULL; ch = ch->next )
		    if ( ch->description == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    break;

	case MEM_MOB_SPEC_FUN_NAME_FREE_CHAR:
	    count++;
	case MEM_MOB_SPEC_FUN_NAME:
	    for ( iHash = 0; iHash < MAX_KEY_HASH; iHash++ )
		for ( pMobIndex = mob_index_hash[iHash];
		pMobIndex != NULL; pMobIndex = pMobIndex->next )
		    if ( pMobIndex->spec_fun_name == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    for ( ch = char_list; ch != NULL; ch = ch->next )
		    if ( ch->spec_fun_name == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    break;

	case MEM_MOB_SHOP_MESSAGE:
	    for ( p = shop_first; p != NULL; p = p->next )
		for ( i = 0; i < SHOP_MAX_MESSAGE; i++ )
		    if ( p->shop_messages[i] == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    break;

	case MEM_OBJ_NAME:
	    for ( iHash = 0; iHash < MAX_KEY_HASH; iHash++ )
		for ( pObjIndex = obj_index_hash[iHash];
		pObjIndex != NULL; pObjIndex = pObjIndex->next )
		    if ( pObjIndex->name == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    for ( obj = object_list; obj != NULL; obj = obj->next )
		    if ( obj->name == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    break;

	case MEM_OBJ_SHORT_DESCR:
	    for ( iHash = 0; iHash < MAX_KEY_HASH; iHash++ )
		for ( pObjIndex = obj_index_hash[iHash];
		pObjIndex != NULL; pObjIndex = pObjIndex->next )
		    if ( pObjIndex->short_descr == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    for ( obj = object_list; obj != NULL; obj = obj->next )
		    if ( obj->short_descr == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    break;

	case MEM_OBJ_LOOK_DESCR:
	    for ( iHash = 0; iHash < MAX_KEY_HASH; iHash++ )
		for ( pObjIndex = obj_index_hash[iHash];
		pObjIndex != NULL; pObjIndex = pObjIndex->next )
		    if ( pObjIndex->look_descr == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    for ( obj = object_list; obj != NULL; obj = obj->next )
		    if ( obj->look_descr == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    break;

	case MEM_OBJ_DESCRIPTION:
	    for ( iHash = 0; iHash < MAX_KEY_HASH; iHash++ )
		for ( pObjIndex = obj_index_hash[iHash];
		pObjIndex != NULL; pObjIndex = pObjIndex->next )
		    if ( pObjIndex->description == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    for ( obj = object_list; obj != NULL; obj = obj->next )
		    if ( obj->description == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    break;

	case MEM_OBJ_SPEC_FUN_NAME:
	    for ( iHash = 0; iHash < MAX_KEY_HASH; iHash++ )
		for ( pObjIndex = obj_index_hash[iHash];
		pObjIndex != NULL; pObjIndex = pObjIndex->next )
		    if ( pObjIndex->spec_fun_name == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    for ( obj = object_list; obj != NULL; obj = obj->next )
		    if ( obj->spec_fun_name == pstr )
			if ( count == 1 )
			    return TRUE;
			else
			    count++;
	    break;

	default:
	    return FALSE;
    }

    return FALSE;
}



void do_areas( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    AREA_DATA *pArea1;
/*
    AREA_DATA *pArea2;
    int iArea;
    int iAreaHalf;
*/

/*
    iAreaHalf = (top_area + 1) / 2;
    pArea1    = area_first;
    pArea2    = area_first;
    for ( iArea = 0; iArea < iAreaHalf; iArea++ )
	pArea2 = pArea2->next;
*/

/*
    for ( iArea = 0; iArea < iAreaHalf; iArea++ )
    {
	sprintf( buf, "%c%-39s%c%-39s\n\r",
	    ( IS_SET( pArea1->area_bits, ZONE_NOROOMS ) ? '*' : ' ' ),
	    pArea1->name,
	    ( (pArea2 != NULL) ?
	     (IS_SET( pArea2->area_bits, ZONE_NOROOMS ) ? '*' : ' ' ) : ' '),
	    ( (pArea2 != NULL) ?
	     pArea2->name : "" ) );
	send_to_char( buf, ch );
	pArea1 = pArea1->next;
	if ( pArea2 != NULL )
	    pArea2 = pArea2->next;
    }
*/
    for ( pArea1 = area_first; pArea1 != NULL; pArea1 = pArea1->next )
    {
	sprintf( buf, "%-39s %6d %6d %10s\n\r",
	    pArea1->name,
	    pArea1->vnum_start,
	    pArea1->vnum_final,
	    ( IS_SET( pArea1->area_bits, ZONE_NOROOMS ) ? "(no rooms)" : " " ));
	send_to_char( buf, ch );
    }

    return;
}



void do_memory( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];

    sprintf( buf, "Affects %5d\n\r", top_affect    ); send_to_char( buf, ch );
    sprintf( buf, "Areas   %5d\n\r", top_area      ); send_to_char( buf, ch );
    sprintf( buf, "ExDes   %5d\n\r", top_ed        ); send_to_char( buf, ch );
    sprintf( buf, "Exits   %5d\n\r", top_exit      ); send_to_char( buf, ch );
    sprintf( buf, "Helps   %5d\n\r", top_help      ); send_to_char( buf, ch );
    sprintf( buf, "Mobs    %5d\n\r", top_mob_index ); send_to_char( buf, ch );
    sprintf( buf, "Objs    %5d\n\r", top_obj_index ); send_to_char( buf, ch );
    sprintf( buf, "Resets  %5d\n\r", top_reset     ); send_to_char( buf, ch );
    sprintf( buf, "Rooms   %5d\n\r", top_room      ); send_to_char( buf, ch );
    sprintf( buf, "Shops   %5d\n\r", top_shop      ); send_to_char( buf, ch );

    sprintf( buf, "Strings %5d strings of %7d bytes (max %d).\n\r",
	nAllocString, sAllocString, MAX_STRING );
    send_to_char( buf, ch );

    sprintf( buf, "Perms   %5d blocks  of %7d bytes.\n\r",
	nAllocPerm, sAllocPerm );
    send_to_char( buf, ch );

    return;
}



/*
 * Stick a little fuzz on a number.
 */
int number_fuzzy( int number )
{
    switch ( number_bits( 2 ) )
    {
    case 0:  number -= 1; break;
    case 3:  number += 1; break;
    }

    return UMAX( 1, number );
}



/*
 * Generate a random number.
 */
int number_range( int from, int to )
{
    int power;
    int number;

    if ( ( to = to - from + 1 ) <= 1 )
	return from;

    for ( power = 2; power < to; power <<= 1 )
	;

    while ( ( number = number_mm( ) & (power - 1) ) >= to )
	;

    return from + number;
}



/*
 * Generate a percentile roll.
 */
int number_percent( void )
{
    int percent;

    while ( ( percent = number_mm( ) & (128-1) ) > 99 )
	;

    return 1 + percent;
}



/*
 * Generate a random door.
 */
int number_door( void )
{
    int door;

    while ( ( door = number_mm( ) & (8-1) ) > 5 )
	;

    return door;
}


/*
 * Get a valid stat # for a player character
 */
int number_stat( void )
{
    return (dice(5,11)+70);
}



int number_bits( int width )
{
    return number_mm( ) & ( ( 1 << width ) - 1 );
}



/*
 * I've gotten too many bad reports on OS-supplied random number generators.
 * This is the Mitchell-Moore algorithm from Knuth Volume II.
 * Best to leave the constants alone unless you've read Knuth.
 * -- Furey
 */
static	int	rgiState[2+55];

void init_mm( )
{
    int *piState;
    int iState;

    piState	= &rgiState[2];

    piState[-2]	= 55 - 55;
    piState[-1]	= 55 - 24;

    piState[0]	= ((int) current_time) & ((1 << 30) - 1);
    piState[1]	= 1;
    for ( iState = 2; iState < 55; iState++ )
    {
	piState[iState] = (piState[iState-1] + piState[iState-2])
			& ((1 << 30) - 1);
    }
    return;
}



int number_mm( void )
{
    int *piState;
    int iState1;
    int iState2;
    int iRand;

    piState		= &rgiState[2];
    iState1	 	= piState[-2];
    iState2	 	= piState[-1];
    iRand	 	= (piState[iState1] + piState[iState2])
			& ((1 << 30) - 1);
    piState[iState1]	= iRand;
    if ( ++iState1 == 55 )
	iState1 = 0;
    if ( ++iState2 == 55 )
	iState2 = 0;
    piState[-2]		= iState1;
    piState[-1]		= iState2;
    return iRand >> 6;
}



/*
 * Roll some dice.
 */
int dice( int number, int size )
{
    int idice;
    int sum;

    switch ( size )
    {
    case 0: return 0;
    case 1: return number;
    }

    for ( idice = 0, sum = 0; idice < number; idice++ )
	sum += number_range( 1, size );

    return sum;
}



/*
 * Removes the tildes from a string.
 * Used for player-entered strings that go into disk files.
 */
void smash_tilde( char *str )
{
    for ( ; *str != '\0'; str++ )
    {
	if ( *str == '~' )
	    *str = '-';
    }

    return;
}



/*
 * Compare strings, case insensitive.
 * Return TRUE if different
 *   (compatibility with historical functions).
 */
bool str_cmp( const char *astr, const char *bstr )
{
    if ( astr == NULL )
    {
	bug( "Str_cmp: null astr.", 0 );
	return TRUE;
    }

    if ( bstr == NULL )
    {
	bug( "Str_cmp: null bstr.", 0 );
	return TRUE;
    }

    for ( ; *astr || *bstr; astr++, bstr++ )
    {
	if ( LOWER(*astr) != LOWER(*bstr) )
	    return TRUE;
    }

    return FALSE;
}



/*
 * Compare strings, case insensitive, for prefix matching.
 * Return TRUE if astr not a prefix of bstr
 *   (compatibility with historical functions).
 */
bool str_prefix( const char *astr, const char *bstr )
{
    if ( astr == NULL )
    {
	bug( "Strn_cmp: null astr.", 0 );
	return TRUE;
    }

    if ( bstr == NULL )
    {
	bug( "Strn_cmp: null bstr.", 0 );
	return TRUE;
    }

    for ( ; *astr; astr++, bstr++ )
    {
	if ( LOWER(*astr) != LOWER(*bstr) )
	    return TRUE;
    }

    return FALSE;
}



/*
 * Compare strings, case insensitive, for match anywhere.
 * Returns TRUE is astr not part of bstr.
 *   (compatibility with historical functions).
 */
bool str_infix( const char *astr, const char *bstr )
{
    int sstr1;
    int sstr2;
    int ichar;
    char c0;

    if ( ( c0 = LOWER(astr[0]) ) == '\0' )
	return FALSE;

    sstr1 = strlen(astr);
    sstr2 = strlen(bstr);

    for ( ichar = 0; ichar <= sstr2 - sstr1; ichar++ )
    {
	if ( c0 == LOWER(bstr[ichar]) && !str_prefix( astr, bstr + ichar ) )
	    return FALSE;
    }

    return TRUE;
}



/*
 * Compare strings, case insensitive, for suffix matching.
 * Return TRUE if astr not a suffix of bstr
 *   (compatibility with historical functions).
 */
bool str_suffix( const char *astr, const char *bstr )
{
    int sstr1;
    int sstr2;

    sstr1 = strlen(astr);
    sstr2 = strlen(bstr);
    if ( sstr1 <= sstr2 && !str_cmp( astr, bstr + sstr2 - sstr1 ) )
	return FALSE;
    else
	return TRUE;
}



/*
 * Returns an initial-capped string.
 */
char *capitalize( const char *str )
{
    static char strcap[MAX_STRING_LENGTH];
    int i;

    for ( i = 0; str[i] != '\0'; i++ )
	strcap[i] = LOWER(str[i]);
    strcap[i] = '\0';
    strcap[0] = UPPER(strcap[0]);
    return strcap;
}



/*
 * Append a string to a file.
 */
void append_file( CHAR_DATA *ch, char *file, char *str )
{
    FILE *fp;

    if ( IS_NPC(ch) || str[0] == '\0' )
	return;

    fclose( fpReserve );
    if ( ( fp = fopen( file, "a" ) ) == NULL )
    {
	perror( file );
	send_to_char( "Could not open the file!\n\r", ch );
    }
    else
    {
	fprintf( fp, "[%5d] %s: %s\n",
	    ch->in_room ? ch->in_room->vnum : 0, ch->name, str );
	fclose( fp );
    }

    fpReserve = fopen( NULL_FILE, "r" );
    return;
}



/*
 * Reports a bug.
 */
void bug( const char *str, int param )
{
    char buf[MAX_STRING_LENGTH];
    FILE *fp;

    if ( fpArea != NULL )
    {
	int iLine;
	int iChar;

	if ( fpArea == stdin )
	{
	    iLine = 0;
	}
	else
	{
	    iChar = ftell( fpArea );
	    fseek( fpArea, 0, 0 );
	    for ( iLine = 0; ftell( fpArea ) < iChar; iLine++ )
	    {
		while ( getc( fpArea ) != '\n' )
		    ;
	    }
	    fseek( fpArea, iChar, 0 );
	}

	sprintf( buf, "[*****] FILE: %s LINE: %d", strArea, iLine );
	log_string( buf );

	if ( ( fp = fopen( "shutdown.txt", "a" ) ) != NULL )
	{
	    fprintf( fp, "[*****] %s\n", buf );
	    fclose( fp );
	}
    }

    strcpy( buf, "[*****] BUG: " );
    sprintf( buf + strlen(buf), str, param );
    log_string( buf );

    fclose( fpReserve );
    if ( ( fp = fopen( BUG_FILE, "a" ) ) != NULL )
    {
	fprintf( fp, "%s\n", buf );
	fclose( fp );
    }
    fpReserve = fopen( NULL_FILE, "r" );

    return;
}



/*
 * Writes a string to the log.
 */
void log_string( const char *str )
{
    char *strtime;

    strtime                    = ctime( &current_time );
    strtime[strlen(strtime)-1] = '\0';
    fprintf( stderr, "%s :: %s\n", strtime, str );
    return;
}



/*
 * This function is here to aid in debugging.
 * If the last expression in a function is another function call,
 *   gcc likes to generate a JMP instead of a CALL.
 * This is called "tail chaining."
 * It hoses the debugger call stack for that call.
 * So I make this the last call in certain critical functions,
 *   where I really need the call stack to be right for debugging!
 *
 * If you don't understand this, then LEAVE IT ALONE.
 * Don't remove any calls to tail_chain anywhere.
 *
 * -- Furey
 */
void tail_chain( void )
{
    return;
}
